	var hosts = "";
	
	opera.extension.onmessage = function(event){
		hosts = event.data;
		doreplace();
	};

	window.addEventListener("DOMContentLoaded", function(){opera.extension.postMessage("How?");}, false);

	function doreplace(){
		if(hosts != 'disable'){
			parser	=	new window.DOMParser();
			var xmlDoc = parser.parseFromString(hosts, "text/xml");
			var aDocument = document;
			var tempstr = "";
			// Replace text nodes
			var textNodesXpath = "/html/head/title/text()"
							   + "|/html/body/text()"
							   + "|/html/body//body/text()" // this happens in Gmail (//iframe/html/body/text())
							   + "|/html/body//div/text()"
							   + "|/html/body//span/text()"
							   + "|/html/body//h1/text()"
							   + "|/html/body//h2/text()"
							   + "|/html/body//h3/text()"
							   + "|/html/body//h4/text()"
							   + "|/html/body//h5/text()"
							   + "|/html/body//h6/text()"
							   + "|/html/body//address/text()"
							   + "|/html/body//bdo/text()"
							   + "|/html/body//em/text()"
							   + "|/html/body//strong/text()"
							   + "|/html/body//dfn/text()"
							   + "|/html/body//code/text()"
							   + "|/html/body//samp/text()"
							   + "|/html/body//kbd/text()"
							   + "|/html/body//var/text()"
							   + "|/html/body//cite/text()"
							   + "|/html/body//abbr/text()"
							   + "|/html/body//acronym/text()"
							   + "|/html/body//q/text()"
							   + "|/html/body//sub/text()"
							   + "|/html/body//sup/text()"
							   + "|/html/body//p/text()"
							   + "|/html/body//pre/text()"
							   + "|/html/body//ins/text()"
							   + "|/html/body//del/text()"
							   + "|/html/body//li/text()"
							   + "|/html/body//ol/text()"
							   + "|/html/body//dt/text()"
							   + "|/html/body//dd/text()"
							   + "|/html/body//caption/text()"
							   + "|/html/body//th/text()"
							   + "|/html/body//td/text()"
							   + "|/html/body//a/text()"
							   + "|/html/body//object/text()"
							   + "|/html/body//tt/text()"
							   + "|/html/body//i/text()"
							   + "|/html/body//b/text()"
							   + "|/html/body//big/text()"
							   + "|/html/body//small/text()"
							   + "|/html/body//noframes/text()"
							   + "|/html/body//iframe/text()"
							   + "|/html/body//button/text()"
							   + "|/html/body//option/text()"
							   + "|/html/body//textarea/text()"
							   + "|/html/body//label/text()"
							   + "|/html/body//fieldset/text()"
							   + "|/html/body//legend/text()"
							   + "|/html/body//font/text()";
			var textNodes = aDocument.evaluate(textNodesXpath, aDocument, null, window.XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
			var nTextNodes = textNodes.snapshotLength;
			for (var i = 0; i < nTextNodes; i++) {
				var textNode = textNodes.snapshotItem(i);
				tempstr = textNode.textContent;
				for(var j=0;j<xmlDoc.getElementsByTagName("host").length;j++){
					tempstr = replaceit(tempstr, xmlDoc.getElementsByTagName("host")[j].childNodes[0].nodeValue, xmlDoc.getElementsByTagName("regex")[j].childNodes[0].nodeValue);
				}
				if(tempstr != textNode.textContent){textNode.textContent = tempstr;}
			}

			// Replace nodes with a "value" property
			var valueNodesXpath = "/html/body//input[@type='text']"
								+ "|/html/body//textarea"
								+ "|/html/body//@abbr"
								+ "|/html/body//@abbr"
								+ "|/html/body//@alt"
								+ "|/html/body//@label"
								+ "|/html/body//@standby"
								+ "|/html/body//@summary"
								+ "|/html/body//@title"
								+ "|/html/body//input[@type!='hidden']/@value"
								+ "|/html/body//option/@value"
								+ "|/html/body//button/@value";
			valueNodesXpath += "|/html/body//a/@href"
								+ "|/html/body//img/@src";
			var valueNodes =
				aDocument.evaluate(valueNodesXpath, aDocument, null, window.XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
			var nValueNodes = valueNodes.snapshotLength;
			for (var i = 0; i < nValueNodes; i++) {
				var valueNode = valueNodes.snapshotItem(i);
				tempstr = valueNode.value;
				for(var j=0;j<xmlDoc.getElementsByTagName("host").length;j++){
					tempstr = replaceit(tempstr, xmlDoc.getElementsByTagName("host")[j].childNodes[0].nodeValue, xmlDoc.getElementsByTagName("regex")[j].childNodes[0].nodeValue);
				}
				if(tempstr != valueNode.value){valueNode.value = tempstr;}
			}
		}
	}
	
	function replaceit(str, w, t){
		var re = new RegExp(w);
		while(str.match(re)){
			str = str.replace(new RegExp(w, 'gi'),t);
		}
		return str;
	}